

/****** Object : Table [dbo].[ShareTemp] Copyright TECK SYSTEM SOFT 2015 ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Share] = '' WHERE [Share] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[Share]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Share]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)

SELECT  
GETDATE()
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Share]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,CONVERT(nvarchar(10),[Availability])

FROM

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Share] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	   /*,[Insert_Date] Add for test purpose only */
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Share]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Availability]  

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp]
WHERE [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Share] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Share] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  as SEARCH_STRING 
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Share]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Share] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability],
     [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Share] SHARES,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Share_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Share],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND 
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Share] =  TEMP_JOIN .[Share] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Share_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Share],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Share_ID) = TEMP_JOIN.[Share_ID]) AS REQUEST

WHERE
SHARES.[Customer] = REQUEST.[Customer]
AND SHARES.[Site] = REQUEST.[Site]
AND SHARES.[Domain] = REQUEST.[Domain]
AND SHARES.[Computer] = REQUEST.[Computer]
AND SHARES.[Alarm] = REQUEST.[Alarm]
AND SHARES.[Status] = REQUEST.[Status]
AND SHARES.[Availability] = REQUEST.[Availability]

/****** Object : Clean Temporary SQL Table ******/

 TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[ShareTemp]
